﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Collections.ObjectModel;

namespace INT_PT002.DataStore
{
    #region SystemConfiguration
    public class SystemConfiguration
    {
        #region Field
        private bool m_IS_LOGIN;

        private int m_RECIPE_NUMBER;

        private Define.E_LanguageID m_LANGUAGE;
        private Define.E_FormStore m_CURRENT_FORM;
        private UserItem m_CURRENT_USER;

        private int m_CHART1_DRAW_STEP;
        private int m_CHART2_DRAW_STEP;

        private int m_LCD_DATA_PERIOD;
        private int m_CHATTERING;
        private int m_JUDGMENT_DELAY_MSEC;
        private int m_BUZZER_OP;

        private int m_SB_DIFF_FILTER;
        private int m_SB_DIFF_MODE;
        private int m_SB_DATA_MODE;
        private int m_SB_DATA_PERIOD;

        private string m_SERIAL_NUMBER;

        private int m_AUTOMATIC_LOGOUT;

        private string m_LEVEL1_NAME;
        private string m_LEVEL2_NAME;
        private string m_LEVEL3_NAME;
        #endregion

        #region Constructor
        public SystemConfiguration()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public bool IS_LOGIN
        {
            get { return this.m_IS_LOGIN; }
            set { this.m_IS_LOGIN = value; }
        }

        public int RECIPE_NUMBER
        {
            get { return this.m_RECIPE_NUMBER; }
            set { this.m_RECIPE_NUMBER = value; }
        }

        public Define.E_LanguageID LANGUAGE
        {
            get { return this.m_LANGUAGE; }
            set { this.m_LANGUAGE = value; }
        }
        public Define.E_FormStore CURRENT_FORM
        {
            get { return this.m_CURRENT_FORM; }
            set { this.m_CURRENT_FORM = value; }
        }
        public UserItem CURRENT_USER
        {
            get { return this.m_CURRENT_USER; }
            set { this.m_CURRENT_USER = value; }
        }

        public int CHART1_DRAW_STEP
        {
            get { return this.m_CHART1_DRAW_STEP; }
            set { this.m_CHART1_DRAW_STEP = value; }
        }
        public int CHART2_DRAW_STEP
        {
            get { return this.m_CHART2_DRAW_STEP; }
            set { this.m_CHART2_DRAW_STEP = value; }
        }

        public int LCD_DATA_PERIOD
        {
            get { return this.m_LCD_DATA_PERIOD; }
            set { this.m_LCD_DATA_PERIOD = value; }
        }
        public int CHATTERING
        {
            get { return this.m_CHATTERING; }
            set { this.m_CHATTERING = value; }
        }
        public int JUDGMENT_DELAY_MSEC
        {
            get { return this.m_JUDGMENT_DELAY_MSEC; }
            set { this.m_JUDGMENT_DELAY_MSEC = value; }
        }
        public int BUZZER_OP
        {
            get { return this.m_BUZZER_OP; }
            set { this.m_BUZZER_OP = value; }
        }

        public int SB_DIFF_FILTER
        {
            get { return this.m_SB_DIFF_FILTER; }
            set { this.m_SB_DIFF_FILTER = value; }
        }
        public int SB_DIFF_MODE
        {
            get { return this.m_SB_DIFF_MODE; }
            set { this.m_SB_DIFF_MODE = value; }
        }
        public int SB_DATA_MODE
        {
            get { return this.m_SB_DATA_MODE; }
            set { this.m_SB_DATA_MODE = value; }
        }
        public int SB_DATA_PERIOD
        {
            get { return this.m_SB_DATA_PERIOD; }
            set { this.m_SB_DATA_PERIOD = value; }
        }

        public string SERIAL_NUMBER
        {
            get { return this.m_SERIAL_NUMBER; }
            set { this.m_SERIAL_NUMBER = value; }
        }

        public int AUTOMATIC_LOGOUT
        {
            get { return this.m_AUTOMATIC_LOGOUT; }
            set { this.m_AUTOMATIC_LOGOUT = value; }
        }

        public string LEVEL1_NAME
        {
            get { return this.m_LEVEL1_NAME; }
            set { this.m_LEVEL1_NAME = value; }
        }
        public string LEVEL2_NAME
        {
            get { return this.m_LEVEL2_NAME; }
            set { this.m_LEVEL2_NAME = value; }
        }
        public string LEVEL3_NAME
        {
            get { return this.m_LEVEL3_NAME; }
            set { this.m_LEVEL3_NAME = value; }
        }
        #endregion

        #region Method
        public void Initialize()
        {
            this.IS_LOGIN = false;

            this.RECIPE_NUMBER = 1;

            this.LANGUAGE = Define.E_LanguageID.Korean;
            this.CURRENT_FORM = Define.E_FormStore.FormNone;
            this.CURRENT_USER = new UserItem();

            this.CHART1_DRAW_STEP = 4;
            this.CHART2_DRAW_STEP = 2;

            this.LCD_DATA_PERIOD = 100;
            this.CHATTERING = 500;
            this.JUDGMENT_DELAY_MSEC = 2000;
            this.BUZZER_OP = 1000;

            this.SB_DIFF_FILTER = 15;
            this.SB_DIFF_MODE = 1;
            this.SB_DATA_MODE = 2;
            this.SB_DATA_PERIOD = 100;

            this.SERIAL_NUMBER = "23C0000";

            this.AUTOMATIC_LOGOUT = 10;

            this.LEVEL1_NAME = "Level 1";
            this.LEVEL2_NAME = "Level 2";
            this.LEVEL3_NAME = "Level 3";
        }
        #endregion
    }
    #endregion
    #region Struct SystemConfiguration
    [StructLayout(LayoutKind.Sequential)]
    public struct StructSystemConfigurationItem
    {
        public int RECIPE_NUMBER;
        public Define.E_LanguageID LANGUAGE;

        public int CHART1_DRAW_STEP;
        public int CHART2_DRAW_STEP;

        public int LCD_DATA_PERIOD;
        public int CHATTERING;
        public int JUDGMENT_DELAY_MSEC;
        public int BUZZER_OP;

        public int SB_DIFF_FILTER;
        public int SB_DIFF_MODE;
        public int SB_DATA_MODE;
        public int SB_DATA_PERIOD;

        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 10)]
        public string SERIAL_NUMBER;

        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string LEVEL1_NAME;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string LEVEL2_NAME;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string LEVEL3_NAME;
    }
    #endregion

    #region User
    public class CollectionUser
    {
        #region Field
        private Collection<User> m_Level1Users;
        private Collection<User> m_Level2Users;
        private Collection<User> m_Level3Users;

        private User m_DefaultUsers;
        private User m_DeveloperUser;
        #endregion

        #region Constructor
        public CollectionUser()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public Collection<User> Level1Users
        {
            get { return this.m_Level1Users; }
            set { this.m_Level1Users = value; }
        }
        public Collection<User> Level2Users
        {
            get { return this.m_Level2Users; }
            set { this.m_Level2Users = value; }
        }
        public Collection<User> Level3Users
        {
            get { return this.m_Level3Users; }
            set { this.m_Level3Users = value; }
        }

        public User DefaultUsers
        {
            get { return this.m_DefaultUsers; }
            set { this.m_DefaultUsers = value; }
        }
        public User DeveloperUser
        {
            get { return this.m_DeveloperUser; }
            private set { this.m_DeveloperUser = value; }
        }
        #endregion

        #region Method
        private void Initialize()
        {
            this.Level1Users = new Collection<User>();
            this.Level2Users = new Collection<User>();
            this.Level3Users = new Collection<User>();

            this.Level1Users.Clear();
            this.Level2Users.Clear();
            this.Level3Users.Clear();

            for (int i = 0; i < 5; i++)
            {
                this.Level1Users.Add(new User());
                this.Level2Users.Add(new User());
                this.Level3Users.Add(new User());
            }

            this.DefaultUsers = new User();

            this.DeveloperUser = new User();
            this.DeveloperUser.ID = "Intech";
            this.DeveloperUser.Password = "20090810";
            this.DeveloperUser.Group = Define.E_UserStatus.Developer;
        }

        public User FindUser(string id)
        {
            User user = null;

            // 개발자 유저 검색
            if (id == this.DeveloperUser.ID)
            {
                user = new User();
                user.ID = this.DeveloperUser.ID;
                user.Password = this.DeveloperUser.Password;
                user.Group = this.DeveloperUser.Group;
                return user;
            }

            // 일반 유저 검색
            for (int i = 0; i < this.Level1Users.Count; i++)
            {
                if (this.Level1Users[i].Group != Define.E_UserStatus.None)
                {
                    if (this.Level1Users[i].ID.Trim() == id.Trim())
                    {
                        user = new User();
                        user.ID = this.Level1Users[i].ID.Trim();
                        user.Password = this.Level1Users[i].Password;
                        user.Group = this.Level1Users[i].Group;
                        return user;
                    }
                }

                if (this.Level2Users[i].Group != Define.E_UserStatus.None)
                {
                    if (this.Level2Users[i].ID.Trim() == id.Trim())
                    {
                        user = new User();
                        user.ID = this.Level2Users[i].ID.Trim();
                        user.Password = this.Level2Users[i].Password;
                        user.Group = this.Level2Users[i].Group;
                        return user;
                    }
                }

                if (this.Level3Users[i].Group != Define.E_UserStatus.None)
                {
                    if (this.Level3Users[i].ID.Trim() == id.Trim())
                    {
                        user = new User();
                        user.ID = this.Level3Users[i].ID.Trim();
                        user.Password = this.Level3Users[i].Password;
                        user.Group = this.Level3Users[i].Group;
                        return user;
                    }
                }
            }

            return user;
        }
        public User FindDeveloperUser(string id)
        {
            User user = null;

            // 개발자 유저 검색
            if (id == this.DeveloperUser.ID)
            {
                user = new User();
                user.ID = this.DeveloperUser.ID;
                user.Password = this.DeveloperUser.Password;
                user.Group = this.DeveloperUser.Group;
                return user;
            }

            return user;
        }

        public bool SearchID(string id)
        {
            bool ret = false;

            for (int i = 0; i < this.Level1Users.Count; i++)
            {
                if (this.Level1Users[i].ID.Trim() == id.Trim())
                    return ret = true;
            }
            for (int i = 0; i < this.Level2Users.Count; i++)
            {
                if (this.Level2Users[i].ID.Trim() == id.Trim())
                    return ret = true;
            }
            for (int i = 0; i < this.Level3Users.Count; i++)
            {
                if (this.Level3Users[i].ID.Trim() == id.Trim())
                    return ret = true;
            }

            return ret;
        }
        #endregion
    }
    #endregion
    #region User
    public class User
    {
        #region Field
        private string m_ID;
        private string m_Password;
        private Define.E_UserStatus m_Group;
        #endregion

        #region Constructor
        public User()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public string ID
        {
            get { return this.m_ID; }
            set { this.m_ID = value; }
        }
        public string Password
        {
            get { return this.m_Password; }
            set { this.m_Password = value; }
        }
        public Define.E_UserStatus Group
        {
            get { return this.m_Group; }
            set { this.m_Group = value; }
        }
        #endregion

        #region Method
        private void Initialize()
        {
            this.ID = "-";
            this.Password = "-";
            this.Group = Define.E_UserStatus.None;
        }
        #endregion
    }
    #endregion
    #region StructUserItem
    [StructLayout(LayoutKind.Sequential)]
    public struct StructUserItemPrevious
    {
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string ID;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Password;

        public Define.E_UserStatus Group;

        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Dummy1;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Dummy2;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Dummy3;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Dummy4;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Dummy5;
    }
    #endregion

    #region UserGroup
    public class UserGroup
    {
        #region Field
        private UserGroupItem m_Level1;
        private UserGroupItem m_Level2;
        private UserGroupItem m_Level3;
        private UserGroupItem m_Default;
        #endregion

        #region Constructor
        public UserGroup()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public UserGroupItem Level1
        {
            get { return this.m_Level1; }
            set { this.m_Level1 = value; }
        }
        public UserGroupItem Level2
        {
            get { return this.m_Level2; }
            set { this.m_Level2 = value; }
        }
        public UserGroupItem Level3
        {
            get { return this.m_Level3; }
            set { this.m_Level3 = value; }
        }
        public UserGroupItem Default
        {
            get { return this.m_Default; }
            set { this.m_Default = value; }
        }
        #endregion

        #region Method
        private void Initialize()
        {
            this.Level1 = new UserGroupItem();
            this.Level2 = new UserGroupItem();
            this.Level3 = new UserGroupItem();
            this.Default = new UserGroupItem();
        }

        public bool GetSet1AccessRight(Define.E_FormStore display)
        {
            bool ret = false;

            return ret;
        }
        public bool GetSet2AccessRight(Define.E_FormStore display)
        {
            bool ret = false;

            return ret;
        }
        public bool GetSet3AccessRight(Define.E_FormStore display)
        {
            bool ret = false;

            return ret;
        }
        #endregion
    }
    #endregion
    #region UserGroupItem
    public class UserGroupItem
    {
        #region Field
        private bool m_IsMainDisplayProductChange;
        private bool m_IsMainDisplayWeightSetting;
        private bool m_IsMainDisplayClear;
        private bool m_IsMainDisplaySubMenu;

        private bool m_IsMenuProduct;
        private bool m_IsMenuUserSetting;
        private bool m_IsMenuUserGroupEditor;
        private bool m_IsMenuIOTest;
        private bool m_IsMenuEquipmentLog;
        private bool m_IsMenuCheckLog;
        private bool m_IsMenuAlarmList;
        private bool m_IsMenuInformation;
        private bool m_IsMenuStatus;
        #endregion

        #region Constructor
        public UserGroupItem()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public bool IsMainDisplayProductChange
        {
            get { return this.m_IsMainDisplayProductChange; }
            set { this.m_IsMainDisplayProductChange = value; }
        }
        public bool IsMainDisplayWeightSetting
        {
            get { return this.m_IsMainDisplayWeightSetting; }
            set { this.m_IsMainDisplayWeightSetting = value; }
        }
        public bool IsMainDisplayClear
        {
            get { return this.m_IsMainDisplayClear; }
            set { this.m_IsMainDisplayClear = value; }
        }
        public bool IsMainDisplaySubMenu
        {
            get { return this.m_IsMainDisplaySubMenu; }
            set { this.m_IsMainDisplaySubMenu = value; }
        }

        public bool IsMenuProduct
        {
            get { return this.m_IsMenuProduct; }
            set { this.m_IsMenuProduct = value; }
        }
        public bool IsMenuUserSetting
        {
            get { return this.m_IsMenuUserSetting; }
            set { this.m_IsMenuUserSetting = value; }
        }
        public bool IsMenuUserGroupEditor
        {
            get { return this.m_IsMenuUserGroupEditor; }
            set { this.m_IsMenuUserGroupEditor = value; }
        }
        public bool IsMenuIOTest
        {
            get { return this.m_IsMenuIOTest; }
            set { this.m_IsMenuIOTest = value; }
        }

        public bool IsMenuEquipmentLog
        {
            get { return this.m_IsMenuEquipmentLog; }
            set { this.m_IsMenuEquipmentLog = value; }
        }
        public bool IsMenuCheckLog
        {
            get { return this.m_IsMenuCheckLog; }
            set { this.m_IsMenuCheckLog = value; }
        }
        public bool IsMenuAlarmList
        {
            get { return this.m_IsMenuAlarmList; }
            set { this.m_IsMenuAlarmList = value; }
        }
        public bool IsMenuInformation
        {
            get { return this.m_IsMenuInformation; }
            set { this.m_IsMenuInformation = value; }
        }
        public bool IsMenuStatus
        {
            get { return this.m_IsMenuStatus; }
            set { this.m_IsMenuStatus = value; }
        }
        #endregion

        #region Method
        private void Initialize()
        {
            this.IsMainDisplayProductChange = false;
            this.IsMainDisplayWeightSetting = false;
            this.IsMainDisplayClear = false;
            this.IsMainDisplaySubMenu = false;

            this.IsMenuProduct = false;
            this.IsMenuUserSetting = false;
            this.IsMenuUserGroupEditor = false;
            this.IsMenuIOTest = false;
            this.IsMenuEquipmentLog = false;
            this.IsMenuCheckLog = false;
            this.IsMenuAlarmList = false;
            this.IsMenuInformation = false;
            this.IsMenuStatus = false;
        }
        #endregion
    }
    #endregion
    #region StructUserGroupItem(총 메뉴 개수 30개)
    [StructLayout(LayoutKind.Sequential)]
    public struct StructUserGroupItem
    {
        public bool IsMainDisplayProductChange;
        public bool IsMainDisplayWeightSetting;
        public bool IsMainDisplayClear;
        public bool IsMainDispalySubMenu;

        public bool IsMenuProduct;
        public bool IsMenuUserSetting;
        public bool IsMenuUserGroupEditor;
        public bool IsMenuIOTest;
        public bool IsMenuEquipmentLog;
        public bool IsMenuCheckLog;
        public bool IsMenuAlarmList;
        public bool IsMenuInformation;
        public bool IsMenuStatus;

        public bool Dummy1;
        public bool Dummy2;
        public bool Dummy3;
        public bool Dummy4;
        public bool Dummy5;
        public bool Dummy6;
        public bool Dummy7;
        public bool Dummy8;
        public bool Dummy9;
        public bool Dummy10;
        public bool Dummy11;
        public bool Dummy12;
        public bool Dummy13;
        public bool Dummy14;
        public bool Dummy15;
        public bool Dummy16;
        public bool Dummy17;
    }
    #endregion

    #region UserItem
    public class UserItem
    {
        #region Field
        private bool m_IsUpdate;

        private string m_ID;
        private string m_Password;
        private string m_PreviousPassword1;
        private string m_PreviousPassword2;
        private string m_PreviousPassword3;

        private int m_ExpireAccount;
        private int m_ExpirePassword;

        private bool m_IsLockAccount;
        private bool m_IsLockPassword;

        private DateTime m_DateRegister;
        private DateTime m_DateLogin;
        private DateTime m_DateExpireRegister;
        private DateTime m_DateExpireLogin;

        private Define.E_UserStatus m_Status;
        private Define.E_UserGroup m_UserGroup;

        private bool m_IsAdmin;

        private bool m_IsMainProductChange;
        private bool m_IsMainWeightSetting;
        private bool m_IsMainClear;
        private bool m_IsMainSubMenu;

        private bool m_IsMenuProduct;
        private bool m_IsMenuUserSetting;
        private bool m_IsMenuUserGroupEditor;
        private bool m_IsMenuIOTest;
        private bool m_IsMenuEquipmentLog;
        private bool m_IsMenuCheckLog;
        private bool m_IsMenuAlarmList;
        private bool m_IsMenuInformation;
        private bool m_IsMenuStatus;
        #endregion

        #region Constructor
        public UserItem()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public bool IsUpdate
        {
            get { return this.m_IsUpdate; }
            set { this.m_IsUpdate = value; }
        }

        public string ID
        {
            get { return this.m_ID; }
            set { this.m_ID = value; }
        }
        public string Password
        {
            get { return this.m_Password; }
            set { this.m_Password = value; }
        }
        public string PreviousPassword1
        {
            get { return this.m_PreviousPassword1; }
            set { this.m_PreviousPassword1 = value; }
        }
        public string PreviousPassword2
        {
            get { return this.m_PreviousPassword2; }
            set { this.m_PreviousPassword2 = value; }
        }
        public string PreviousPassword3
        {
            get { return this.m_PreviousPassword3; }
            set { this.m_PreviousPassword3 = value; }
        }

        public int ExpireAccount
        {
            get { return this.m_ExpireAccount; }
            set { this.m_ExpireAccount = value; }
        }
        public int ExpirePassword
        {
            get { return this.m_ExpirePassword; }
            set { this.m_ExpirePassword = value; }
        }

        public bool IsLockAccount
        {
            get { return this.m_IsLockAccount; }
            set { this.m_IsLockAccount = value; }
        }
        public bool IsLockPassword
        {
            get { return this.m_IsLockPassword; }
            set { this.m_IsLockPassword = value; }
        }

        public DateTime DateRegister
        {
            get { return this.m_DateRegister; }
            set { this.m_DateRegister = value; }
        }
        public DateTime DateLogin
        {
            get { return this.m_DateLogin; }
            set { this.m_DateLogin = value; }
        }
        public DateTime DateExpireRegister
        {
            get { return this.m_DateExpireRegister; }
            set { this.m_DateExpireRegister = value; }
        }
        public DateTime DateExpireLogin
        {
            get { return this.m_DateExpireLogin; }
            set { this.m_DateExpireLogin = value; }
        }

        public Define.E_UserStatus Status
        {
            get { return this.m_Status; }
            set { this.m_Status = value; }
        }
        public Define.E_UserGroup UserGroup
        {
            get { return this.m_UserGroup; }
            set { this.m_UserGroup = value; }
        }

        public bool IsAdmin
        {
            get { return this.m_IsAdmin; }
            set { this.m_IsAdmin = value; }
        }

        public bool IsMainProductChange
        {
            get { return this.m_IsMainProductChange; }
            set { this.m_IsMainProductChange = value; }
        }
        public bool IsMainWeightSetting
        {
            get { return this.m_IsMainWeightSetting; }
            set { this.m_IsMainWeightSetting = value; }
        }
        public bool IsMainClear
        {
            get { return this.m_IsMainClear; }
            set { this.m_IsMainClear = value; }
        }
        public bool IsMainSubMenu
        {
            get { return this.m_IsMainSubMenu; }
            set { this.m_IsMainSubMenu = value; }
        }

        public bool IsMenuProduct
        {
            get { return this.m_IsMenuProduct; }
            set { this.m_IsMenuProduct = value; }
        }
        public bool IsMenuUserSetting
        {
            get { return this.m_IsMenuUserSetting; }
            set { this.m_IsMenuUserSetting = value; }
        }
        public bool IsMenuUserGroupEditor
        {
            get { return this.m_IsMenuUserGroupEditor; }
            set { this.m_IsMenuUserGroupEditor = value; }
        }
        public bool IsMenuIOTest
        {
            get { return this.m_IsMenuIOTest; }
            set { this.m_IsMenuIOTest = value; }
        }
        public bool IsMenuEquipmentLog
        {
            get { return this.m_IsMenuEquipmentLog; }
            set { this.m_IsMenuEquipmentLog = value; }
        }
        public bool IsMenuCheckLog
        {
            get { return this.m_IsMenuCheckLog; }
            set { this.m_IsMenuCheckLog = value; }
        }
        public bool IsMenuAlarmList
        {
            get { return this.m_IsMenuAlarmList; }
            set { this.m_IsMenuAlarmList = value; }
        }
        public bool IsMenuInformation
        {
            get { return this.m_IsMenuInformation; }
            set { this.m_IsMenuInformation = value; }
        }
        public bool IsMenuStatus
        {
            get { return this.m_IsMenuStatus; }
            set { this.m_IsMenuStatus = value; }
        }
        #endregion

        #region Method
        private void Initialize()
        {
            this.IsUpdate = false;

            this.ID = "-";
            this.Password = "-";

            this.PreviousPassword1 = "-";
            this.PreviousPassword2 = "-";
            this.PreviousPassword3 = "-";

            this.ExpireAccount = 0;
            this.ExpirePassword = 0;

            this.DateRegister = DateTime.Now;
            this.DateLogin = DateTime.Now;
            this.DateExpireRegister = DateTime.Now;
            this.DateExpireLogin = DateTime.Now;

            this.Status = Define.E_UserStatus.None;
            this.UserGroup = Define.E_UserGroup.f3_Default;

            this.IsAdmin = false;

            this.IsMainProductChange = false;
            this.IsMainWeightSetting = false;
            this.IsMainClear = false;
            this.IsMainSubMenu = false;

            this.IsMenuProduct = false;
            this.IsMenuUserSetting = false;
            this.IsMenuUserGroupEditor = false;
            this.IsMenuIOTest = false;
            this.IsMenuEquipmentLog = false;
            this.IsMenuCheckLog = false;
            this.IsMenuAlarmList = false;
            this.IsMenuInformation = false;
            this.IsMenuStatus = false;
        }

        public void SetPassword(string pass)
        {
            this.PreviousPassword3 = this.PreviousPassword2;
            this.PreviousPassword2 = this.PreviousPassword1;
            this.PreviousPassword1 = pass;
            this.Password = pass;
        }
        public bool CheckID(string id)
        {
            bool ret = false;


            return ret;
        }
        public bool CheckPassword(string pass)
        {
            bool ret = false;

            return ret;
        }
        #endregion
    }
    #endregion
    #region StructUserItem
    [StructLayout(LayoutKind.Sequential)]
    public struct StructUserItem
    {
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string ID;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string Password;

        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string PreviousPassword1;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string PreviousPassword2;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 20)]
        public string PreviousPassword3;

        public int ExpireAccount;
        public int ExpirePassword;

        public DateTime DateRegister;
        public DateTime DateLogin;

        public bool IsAdmin;

        public bool IsMainProductChange;
        public bool IsMainWeightSetting;
        public bool IsMainClear;
        public bool IsMainSubMenu;

        public bool IsMenuProduct;
        public bool IsMenuUserSetting;
        public bool IsMenuUserGroupEditor;
        public bool IsMenuIOTest;
        public bool IsMenuEquipmentLog;
        public bool IsMenuCheckLog;
        public bool IsMenuAlarmList;
        public bool IsMenuInformation;
        public bool IsMenuStatus;
    }
    #endregion

    #region HistoryData
    public class HistoryData
    {
        #region Field
        private string m_Type;
        private DateTime m_Time;
        private string m_LoginID;
        private Object m_Event;
        private string m_Detail;
        private string m_BeforeData;
        private string m_AfterData;
        #endregion

        #region Constructor
        public HistoryData()
        {
        }
        #endregion

        #region Property
        public string Type
        {
            get { return this.m_Type; }
            set { this.m_Type = value; }
        }
        public DateTime Time
        {
            get { return this.m_Time; }
            set { this.m_Time = value; }
        }
        public string LoginID
        {
            get { return this.m_LoginID; }
            set { this.m_LoginID = value; }
        }
        public Object Event
        {
            get { return this.m_Event; }
            set { this.m_Event = value; }
        }
        public string Detail
        {
            get { return this.m_Detail; }
            set { this.m_Detail = value; }
        }
        public string BeforeData
        {
            get { return this.m_BeforeData; }
            set { this.m_BeforeData = value; }
        }
        public string AfterData
        {
            get { return this.m_AfterData; }
            set { this.m_AfterData = value; }
        }
        #endregion

        #region Method
        private void Initialize()
        {
            this.Type = "";
            this.Time = new DateTime();
            this.LoginID = "-";
            this.Event = new object();
            this.Detail = "";
            this.AfterData = "";
            this.BeforeData = "";
        }
        #endregion
    }
    #endregion
}
